import type { DatabaseCredentials } from '@prisma/internals';
import { ConnectorType } from './printDatasources';
export type MigrateAction = 'create' | 'apply' | 'unapply' | 'dev' | 'push';
export type PrettyProvider = 'MySQL' | 'PostgreSQL' | 'SQLite' | 'SQL Server' | 'CockroachDB' | 'MongoDB';
export type DatasourceInfo = {
    name?: string;
    prettyProvider?: PrettyProvider;
    url?: string;
    dbLocation?: string;
    dbName?: string;
    schema?: string;
    schemas?: string[];
};
export declare function getDatasourceInfo({ schemaPath, throwIfEnvError, }?: {
    schemaPath?: string;
    throwIfEnvError?: boolean;
}): Promise<DatasourceInfo>;
export declare function ensureCanConnectToDatabase(schemaPath?: string): Promise<Boolean | Error>;
export declare function ensureDatabaseExists(action: MigrateAction, schemaPath?: string): Promise<string | undefined>;
export declare function getDbLocation(credentials: DatabaseCredentials): string | undefined;
/**
 * Return a pretty version of a "provider" (with uppercase characters)
 * @param provider
 * @returns PrettyProvider
 */
export declare function prettifyProvider(provider: ConnectorType): PrettyProvider;
