export type ConnectorType = 'mysql' | 'mongodb' | 'sqlite' | 'postgresql' | 'postgres' | 'sqlserver' | 'cockroachdb';
export interface GeneratorConfig {
    name: string;
    output: string | null;
    provider: string;
    config: Record<string, string>;
}
export type Datasource = string | {
    url: string;
    [key: string]: any;
};
export interface InternalDatasource {
    name: string;
    provider: ConnectorType;
    url: string;
    config: any;
}
export declare function printDatasources(internalDatasources: InternalDatasource[]): string;
export declare function printDatamodelObject(obj: any): string;
