export type SetupParams = {
    connectionString: string;
    dirname: string;
};
export declare function setupPostgres(options: SetupParams): Promise<void>;
export declare function tearDownPostgres(options: SetupParams): Promise<void>;
/**
 * Run an arbitrary query against a Postgres database.
 * Procedural `plpgsql` queries are also supported.
 * This function should be called after `setupPostgres` and before `tearDownPostgres`.
 * The given `options.connectionString` is used as is.
 */
export declare function runQueryPostgres(options: SetupParams, query: string): Promise<void>;
